<?php
/**
 * Created by JetBrains PhpStorm.
 * User: erikasouza
 * Date: 23/11/12
 * Time: 15:56
 * To change this template use File | Settings | File Templates.
 */

namespace Estoque\Logic\FechamentoDia;

use Setforms2\Runtime\Helper\Procedure\Param;


class GeraAjustMov extends \Estoque\Logic\FechamentoDia\ExportAbstract
{

    private $nrorg;
    private $cdFilial;
    private $dtProc;
    private $cdMovi;


    public function __construct($param){
        $this->nrorg = $param['NRORG'];
        $this->cdFilial = $param['CDFILIAL'];
        $this->dtProc = $param['DTPROC'];
        $this->cdMovi = $param['CDMOVI'];
    }


    public function executaProcedure(){
        /** @var $itlanctoestRepository \Estoque\Repositories\Itlanctoest */
        $itlanctoestRepository = \Estoque\Entities\Itlanctoest::getRepository();

        $util = new Util();
        /** @var $primeiroUltimoDia Util */
        $primeiroUltimoDia = $util->primeiroUltimoDiaMes($this->dtProc);
        $ajusteEstoq = $itlanctoestRepository->consultaAjustesEstoque(
            $this->nrorg, $this->cdFilial,
            $primeiroUltimoDia->primeiroDiaMes, $primeiroUltimoDia->ultimoDiaMes
        );

        $produto = new \Geral\Util\PictureProduto($this->nrorg);
        $nivel = $produto->getNumeroDeNiveis();

        foreach ($ajusteEstoq as $ajuste) {
            $params = array(new Param("P_FILIAL",
                Param::PARAM_INPUT,
                $this->cdFilial,
                Param::PARAM_TYPE_STR
            ),
                new Param("P_CDALMOXARIFE",
                    Param::PARAM_INPUT,
                    ' ',
                    Param::PARAM_TYPE_STR
                ),
                new Param("P_CDLOCALESTOQ",
                    Param::PARAM_INPUT,
                    ' ',
                    Param::PARAM_TYPE_STR
                ),
                new Param("P_NRLOTEESTQ",
                    Param::PARAM_INPUT,
                    ' ',
                    Param::PARAM_TYPE_STR
                ),
                new Param("P_TAMNIVEL",
                    Param::PARAM_INPUT,
                    $nivel,
                    Param::PARAM_TYPE_STR
                ),
                new Param("P_DTINICIAL",
                    Param::PARAM_INPUT,
                    $ajuste['DTLANCMOVI'],
                    Param::PARAM_TYPE_STR
                ),
                new Param("P_DTFINAL",
                    Param::PARAM_INPUT,
                    $ajuste['DTLANCMOVIF'],
                    Param::PARAM_TYPE_STR
                ),
                new Param("P_PRODINI",
                    Param::PARAM_INPUT,
                    '0',
                    Param::PARAM_TYPE_STR
                ),
                new Param("P_PRODFIM",
                    Param::PARAM_INPUT,
                    'zzzzzzzzzz',
                    Param::PARAM_TYPE_STR
                ),
                new Param("P_IDLANCTO",
                    Param::PARAM_INPUT,
                    '3',
                    Param::PARAM_TYPE_STR
                ),
                new Param("P_IDCUSTO",
                    Param::PARAM_INPUT,
                    '1',
                    Param::PARAM_TYPE_STR
                ),
                new Param("P_SEQUMOVI",
                    Param::PARAM_INPUT,
                    $this->cdMovi,
                    Param::PARAM_TYPE_STR
                ),
            );

            $this->chamaProcedure('GERA_AJUSTMOV', $params);
        }
    }


    public function executaRelatorio()
    {
        // TODO: Implement executaRelatorio() method.
    }


}
