<?php
namespace Folha\Repositories;

class FpaFormcnab extends \Doctrine\ORM\EntityRepository
{


    public function retornaRegistroEmpresa($nrorg, $nrestruturam, $competencia){

        //$sql = "SELECT * FROM ESTRUTURAM WHERE NRORG='{$nrorg}' AND NRESTRUTURAM='{$nrestruturam}'";
        // felipesantos - 09/04/2015: incluídos código do banco e verificação do tipo de conta para CNAB
        $sql = "SELECT EH.NRESTRUTURAM, EH.NMESTRUTURAH, EH.NRPARCNEGOCIO, CC.CDBANCO, CC.CDAGENCIA, CC.CDCONTCORR, CC.NRTPCONTCORR, EH.NMRAZSOCESTRUT, EH.CDCNPJESTRUT
FROM ESTRUTURAM EM
JOIN ESTRUTURAH EH ON EH.NRORG        = EM.NRORG
                  AND EH.NRESTRUTURAM = EM.NRESTRUTURAM
LEFT JOIN CONTCORRPARC CC ON CC.NRORG         = EM.NRORG
                         AND CC.NRPARCNEGOCIO = EH.NRPARCNEGOCIO
                         AND CC.NRTPCONTCORR = 2 --CNAB
WHERE EM.NRORG        = '{$nrorg}'
  AND EM.NRESTRUTURAM = '{$nrestruturam}'
  AND EH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC
                            FROM ESTRUTURAH
                            WHERE DTMESCOMPETENC <= '{$competencia}'
                              AND NRORG        = EM.NRORG
                              AND NRESTRUTURAM = EM.NRESTRUTURAM )";

        return \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
    }


    /**
     * Retorna condição sql para restrição de vínculos confidenciais
     */
    private function getConfidencial(){
        $confidencial='';
        if(\FPA::getRestConfidencial()==='S'){
            $confidencial = " AND VH.CONFIDENCIAL='N' ";
        }
        return $confidencial;
    }

    /**
     * Retorna os vinculos da competência ordenados por nome de vínculo vínculo
     * filtrando os parametros informados ao método  e considera a restrição de confidencial.
     *
     * @author leandroafonso
     * @params nrorg, dtcompetencia, dsordem, dsinicio, dsfim
     */
    public function retornaRegistrosVinculo($nrorg , $competencia, $nrmodalidade, $nrevento, $tipomovimento,
                                            $cdbanco , $dsOrdem , $dsInicio = null , $dsFim = null, $dtPagamento = null){
        $ocorrencia     = \FPA::getOcorrenciaCalculo();

        // felipesantos - 09/04/2015: incluída data de pagamento
        $sql = "SELECT VM.CDMATRICULA, VM.NRVINCULOM, VM.NMVINCULOM, VM.DTADMISSAOVINC, VM.DTRESCISAOVINC,
                  VH.NRESTRUTGEREN, VH.NRESTRUTLEGAL, ICF.IDEVENDEMONCALC, ICF.VRREFFOLHA, ICF.VREVENTOFOLHA,
                  CF.NRTIPOMOVIMENT, ICF.NRITEMCALCFOLHA, CF.NRCALCULOFOLHA, TPM.NMTIPOMOVIMENT, CC.NRTPCONTCORR,
                  CC.CDCONTCORR, CC.CDAGENCIA, CC.CDBANCO
                FROM GPE_VINCULOM VM
                JOIN GPE_VINCULOH VH
                  ON VH.NRORG      = VM.NRORG
                  AND VH.NRVINCULOM = VM.NRVINCULOM
                JOIN FPA_ITECALCFOLHA ICF
                  ON ICF.NRORG      = VM.NRORG
                  AND ICF.NRVINCULOM = VM.NRVINCULOM
                  AND ICF.DTOCORRENCIA = NVL('{$dtPagamento}', ICF.DTOCORRENCIA)
                JOIN FPA_CALCULOFOLHA CF
                  ON CF.NRORG = VM.NRORG
                  AND CF.NRCALCULOFOLHA = ICF.NRCALCULOFOLHA
                  AND CF.NRTIPOMOVIMENT = '{$tipomovimento}'
                  AND CF.NRTPMODALIDCAL = '{$nrmodalidade}'
                  AND CF.NROCORRECAL    = '{$ocorrencia}'
                  AND CF.DTOCORRENCIA   = '{$competencia}'
                JOIN FPA_TIPOMOVIMENT TPM
                  ON ( TPM.NRORG = VM.NRORG OR TPM.NRORG = 0 )
                  AND TPM.NRTIPOMOVIMENT = CF.NRTIPOMOVIMENT
                JOIN GPE_PESSOA PE
                  ON  PE.NRORG    = VM.NRORG
                  AND PE.NRPESSOA = VM.NRPESSOA
                JOIN CONTCORRPARC CC
                  ON  CC.NRORG = VM.NRORG
                  AND CC.NRPARCNEGOCIO = PE.NRPARCNEGOCIO
                  AND CC.CDBANCO = '{$cdbanco}'
                WHERE VM.NRORG = '{$nrorg}'
                  AND ( VM.DTRESCISAOVINC >= '{$competencia}' OR VM.DTRESCISAOVINC IS NULL )
                  AND ICF.NREVENTOM = '{$nrevento}'
                  AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC)
                                            FROM GPE_VINCULOH
                                            WHERE DTMESCOMPETENC <= '{$competencia}'
                                              AND NRORG      = VM.NRORG
                                              AND NRVINCULOM = VM.NRVINCULOM )
                ";

        switch ($dsOrdem){
            case 'ALFABETICA':
                $condIntervalo = ' AND VM.NMVINCULOM BETWEEN \''.$dsInicio.'\' AND \''.$dsFim.'\'';
                break;
            case 'ESTRUTURA':
                $condIntervalo = ' AND VH.NRESTRUTLEGAL BETWEEN '.$dsInicio.' AND '.$dsFim.'';
                $condIntervalo .= "AND (VH.NRESTRUTGEREN = '$dsFim' OR '$dsFim' IS NULL)";
                break;
            case 'MATRICULA':
                $condIntervalo = 'AND VM.CDMATRICULA BETWEEN \''.$dsInicio.'\' AND \''.$dsFim.'\'';
                break;
            case 'DATA_ADMISSAO':
                $condIntervalo = 'AND VM.DTADMISSAOVINC BETWEEN \''.$dsInicio.'\' AND \''.$dsFim.'\'';
                break;
        }

        $sql.= $this->getConfidencial();
        $sql.= $condIntervalo.= ' ORDER BY VM.NMVINCULOM ';

        return \Setforms2\Runtime\Connection::getInstance()->fetchAll($sql);
    }
}