CREATE TABLE EQUIPRATOCOZ (
  NREQUIPRATOCOZ NUMBER(10) NOT NULL, 
  NREQUIPAMENTO NUMBER(10) NOT NULL, 
  CDFILAUXPRAT VARCHAR2(4) NOT NULL, 
  CDPRATO VARCHAR2(10) NOT NULL, 
  TEMPOPREP VARCHAR2(4) DEFAULT NULL NULL, 
  NRORG NUMBER(10) DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT 1 NULL, 
  NRORGULTATU NUMBER(10) DEFAULT 1 NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1' NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT '1' NULL,
  CONSTRAINT PK_EQUIPRATOCOZ PRIMARY KEY(NREQUIPRATOCOZ)
)
/
ALTER TABLE EQUIPRATOCOZ ADD CONSTRAINT CKC_IDATIVO_EQUIPRATOCOZ CHECK (IDATIVO IN ('S', 'N'))
/
ALTER TABLE EQUIPRATOCOZ ADD CONSTRAINT UN_EQUIPRATOCOZ UNIQUE (NREQUIPAMENTO, CDFILAUXPRAT, CDPRATO)
/
ALTER TABLE EQUIPRATOCOZ ADD CONSTRAINT FKPLA00995EQUIPAMCOZ FOREIGN KEY (NREQUIPAMENTO) REFERENCES EQUIPAMCOZ (NREQUIPAMCOZ)
/
CREATE INDEX FKPLA00995EQUIPAMCOZ ON EQUIPRATOCOZ (NREQUIPAMENTO)
/
ALTER TABLE EQUIPRATOCOZ ADD CONSTRAINT FKPLA00996PRATO FOREIGN KEY (CDFILAUXPRAT, CDPRATO) REFERENCES PRATO (CDFILAUXPRAT, CDPRATO)
/
CREATE INDEX FKPLA00996PRATO ON EQUIPRATOCOZ (CDFILAUXPRAT, CDPRATO)